#ifndef  CLIB_MUIMASTER_PROTOS_H
#define  CLIB_MUIMASTER_PROTOS_H

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif
#ifndef INTUITION_CLASSES_H
#include <intuition/classes.h>
#endif
#ifndef UTILITY_TAGITEM_H
#include <utility/tagitem.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if !defined(EXEC_LIBRARY_H) && !defined(LATTICE_50)
struct Library;
#endif

extern struct Library *MUIMasterBase;

/* functions to be used in applications */

Object *MUI_NewObjectA(const char *, const struct TagItem *);
Object *MUI_NewObject(const char *, Tag, ...);

Object *MUI_MakeObjectA(LONG, const ULONG *);
Object *MUI_MakeObject(LONG, ...);

LONG MUI_RequestA(Object *, Object *, LONGBITS, const char *, const char *, const char *, const APTR);
LONG MUI_Request(Object *, Object *, LONGBITS, const char *, const char *, const char *, ...);

APTR MUI_AllocAslRequest(ULONG, const struct TagItem *);
APTR MUI_AllocAslRequestTags(ULONG, Tag, ...);

BOOL MUI_AslRequest(APTR, const struct TagItem *);
BOOL MUI_AslRequestTags(APTR, Tag, ...);

void MUI_FreeAslRequest(APTR);
void MUI_DisposeObject(Object *obj);
LONG MUI_Error(void);

/* functions to be used with custom classes */

struct IClass *MUI_GetClass (const char *);
void MUI_FreeClass(struct IClass *);

void MUI_RequestIDCMP(Object *, ULONG);
void MUI_RejectIDCMP(Object *, ULONG);

struct MUI_CustomClass *MUI_CreateCustomClass(struct Library *, const char *, struct MUI_CustomClass *, int, APTR);
BOOL MUI_DeleteCustomClass(struct MUI_CustomClass *);

void MUI_Redraw(Object *, ULONG);
LONG MUI_SetError(LONG);

#ifdef __cplusplus
}
#endif
#endif /* CLIB_MUIMASTER_PROTOS_H */
